import os, random
from pyenergyplus.plugin import EnergyPlusPlugin
from pyenergyplus.api import EnergyPlusAPI
from PerformanceCurve import Curve_HPDM_SC, Curve_HPDM_SH
import time 
##############################################################################################

class SetEPAPI():
    def setEPapi(self, EP_api : EnergyPlusAPI):
        self.api = EP_api #replace API with master EnergyPlusAPI  
    

class HVACInterface(EnergyPlusPlugin, SetEPAPI):
    def __init__(self):
        super().__init__()
        self.need_to_get_handles = True
        self.IniObjects()
        
        self.Qtot_Rated = 17947.114
        self.COP_Rated =  3.34
        self.OAT1=0
        self.OAT2=0
        self.ZoneT1=0
        self.ZoneT2=0
        self.Qsen1=0
        self.Qsen2=0
        self.Resistance=0
        self.Capacitance=0
        self.ResistanceAvg=0
        self.CapacitanceAvg=0
        self.ResistanceMax=0
        self.CapacitanceMax=0
        self.ResistanceMin=0
        self.CapacitanceMin=0
        
        #print ("Hey outside hpdm path check: ", os.getcwd())
        #time.sleep(500)
    
# customerized codes below #################################################
    def IniObjects(self):
        # self.zone_list =['living_unit1' ,        
                        # 'attic_unit1' ]
                        
        self.HP_SH = Curve_HPDM_SH()
        
    def get_sensor_handles(self, state):
        self.OAT_sensor_handle = self.api.exchange.get_variable_handle(state,
                                        "Site Outdoor Air Drybulb Temperature", "Environment")

        print ('\n ###################', self.OAT_sensor_handle, '\n ####################')
        
        self.OARH_sensor_handle = self.api.exchange.get_variable_handle(state,
                                        "Site Outdoor Air Humidity Ratio", "Environment")

        print ('\n ###################', self.OARH_sensor_handle, '\n ####################')

        self.ZoneT_Ctrl_Zone_sensor_handle = self.api.exchange.get_variable_handle(state,
                                        "Zone Mean Air Temperature", "living_unit1")

        print ('\n ###################', self.ZoneT_Ctrl_Zone_sensor_handle, '\n ####################')

        
        self.Fan_Massflow_Ctrl_Zone_sensor_handle =  self.api.exchange.get_variable_handle(state,
                                        "Fan Air Mass Flow Rate", "Supply Fan_unit1")

        print('\n ###################', self.Fan_Massflow_Ctrl_Zone_sensor_handle, '\n ####################')
        
        self.Coil_TotHeatRate_handle = self.api.exchange.get_variable_handle(state,
                                        "Heating Coil Heating Rate", "Main DX Heating Coil_unit1")
        
        print('\n ###################', self.Coil_TotHeatRate_handle, '\n ####################')
        
        self.GridSignal_handle = self.api.exchange.get_variable_handle(state,
                                        "Schedule Value", "GridSignal")
        
        print('\n ###################', self.GridSignal_handle, '\n ####################')
        
        self.HeatLoad_handle = self.api.exchange.get_variable_handle(state,
                                        "Schedule Value", "HeatLoad")
        
        print('\n ###################', self.HeatLoad_handle, '\n ####################')
                        
        #time. sleep(5)

        return 0
        
    def get_actuator_handles(self, state):
        ############## performance curve handles ##############                                                                                

        self.Qdot_HP_SH_actuator_handle = self.api.exchange.get_actuator_handle(state,
                                    component_type= "Curve",
                                    control_type='Curve Result',
                                    actuator_key='HPACHeatCapFT')  
                                    
                                    
        self.EIR_HP_SH_actuator_handle = self.api.exchange.get_actuator_handle(state,
                                    component_type= "Curve",
                                    control_type='Curve Result',
                                    actuator_key='HPACHeatEIRFT')   
                  
        self.Qdot_HP_FlowFrac_actuator_handle = self.api.exchange.get_actuator_handle(state,
                                    component_type= "Curve",
                                    control_type='Curve Result',
                                    actuator_key='HPACHeatCapFFF') 
                                    
        self.EIR_HP_FlowFrac_actuator_handle = self.api.exchange.get_actuator_handle(state,
                                    component_type= "Curve",
                                    control_type='Curve Result',
                                    actuator_key='HPACHeatEIRFFF')      
               
        self.PLR_SH_actuator_handle = self.api.exchange.get_actuator_handle(state,
                                    component_type= "Curve",
                                    control_type='Curve Result',
                                    actuator_key='HPACCOOLPLFFPLR')        
        
        self.suppHeater_ON_handle = self.api.exchange.get_actuator_handle(state,
                                    component_type= "Schedule:Constant",
                                    control_type='Schedule Value',
                                    actuator_key='SupplHeaterOn') 
        
        print('\n ###################', self.suppHeater_ON_handle, '\n ####################')
        
        #time. sleep(5)
        
        return 0
      
    def on_end_of_system_timestep_after_hvac_reporting(self, state) -> int:
    
        if self.need_to_get_handles==False:                
            self.OAT2=self.OAT1
            self.ZoneT2=self.ZoneT1
            self.Qsen2=self.Qsen1
            self.OAT1=self.api.exchange.get_variable_value(state, self.OAT_sensor_handle) #C
            self.ZoneT1=self.api.exchange.get_variable_value(state, self.ZoneT_Ctrl_Zone_sensor_handle) #C
            self.Qsen1=self.api.exchange.get_variable_value(state, self.Coil_TotHeatRate_handle)
            print('\n ###################', self.Qsen1, '\n ####################')
            #solve RC model based on last two timesteps
            # self.Resistance=0
            # self.Capacitance=0
            # self.ResistanceAvg=0
            # self.CapacitanceAvg=0
            # self.ResistanceMax=0
            # self.CapacitanceMax=0
            # self.ResistanceMin=0
            # self.CapacitanceMin=0
        
        return 0
        
    def on_begin_timestep_before_predictor(self, state) -> int:
        if self.api.exchange.api_data_fully_ready(state):
            if self.need_to_get_handles:
                self.get_sensor_handles(state)
                self.get_actuator_handles(state)
                self.need_to_get_handles = False
                
            DayLeak : int = self.api.exchange.day_of_year(state)
            SupHeatOn : int = 1
            
            
            # get some variables from building, whcih are input to HPDM
            # C to F
            OAT = self.api.exchange.get_variable_value(state, self.OAT_sensor_handle) * 1.8 +32
            # humidity % to -
            OARH = self.api.exchange.get_variable_value(state, self.OARH_sensor_handle)*0.01
            
            GridDataHr = self.api.exchange.get_variable_value(state, self.GridSignal_handle)            
            HeatLoadHr = self.api.exchange.get_variable_value(state, self.HeatLoad_handle)
            
            print ('grid signal and hourly heat load : ', GridDataHr, "---&---", HeatLoadHr)
            
            # C to F
            ZoneT_Ctrl = self.api.exchange.get_variable_value(state, self.ZoneT_Ctrl_Zone_sensor_handle)* 1.8 +32
                        
            # MFR kg/s to lbs/hour
            #SAMass_Ctrl = self.api.exchange.get_variable_value(state, self.Fan_Massflow_Ctrl_Zone_sensor_handle) *7936.64
            
            self.HP_SH.get_input_variables( heating_cap_rated=self.Qtot_Rated, air_temperature_indoor=ZoneT_Ctrl, air_rh_outdoor=OARH, air_temperature_outdoor=OAT )
            (Qnet, Qcoil, Power_SH) = self.HP_SH.get_output_variable()
            print ('Core zone HP results : ', Qnet, Qcoil, Power_SH)
            
            if OAT>25:
            #no supplemental heater
                SupHeatOn=0
            else:
            #only run the supplemental heater
                SupHeatOn=1
                Qnet=0.0
                Power_SH=0.0
                Qcoil = 0.0
            
            #turn the supplemental heater ON/OFF
            self.api.exchange.set_actuator_value(state, self.suppHeater_ON_handle, SupHeatOn )
            
            if Power_SH<1e-3:
                COP_SH =0.001
            else:
                COP_SH = Qnet/Power_SH/3.412
                          
            print('\n ###################', COP_SH, '\n ####################')
            
            curve_Qdot_HP_SH = Qnet/self.Qtot_Rated
            
            print('\n ###################', curve_Qdot_HP_SH, '\n ####################')

            self.api.exchange.set_actuator_value(state, self.Qdot_HP_SH_actuator_handle, curve_Qdot_HP_SH )

            curve_Qdot_HP_FlowFrac = 1
            self.api.exchange.set_actuator_value(state, self.Qdot_HP_FlowFrac_actuator_handle, curve_Qdot_HP_FlowFrac )
                      
            curve_EIR_HP_SH = self.COP_Rated/COP_SH       
            self.api.exchange.set_actuator_value(state, self.EIR_HP_SH_actuator_handle, curve_EIR_HP_SH )

            curve_EIR_HP_FlowFrac = 1 
            self.api.exchange.set_actuator_value(state, self.EIR_HP_FlowFrac_actuator_handle, curve_EIR_HP_FlowFrac )
          
                
        return 0
    

